//+------------------------------------------------------------------+
//|                                             ChangeRectColour.mq4 |
//|                                            Copyright 2019, ernst |
//|                             https://www.mql5.com/en/users/pippod |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, ernst"
#property link      "https://www.mql5.com/en/users/pippod"
#property version   "1.00"
#property strict
#property indicator_chart_window
#include <ChartObjects\ChartObjectsTxtControls.mqh>
CChartObjectLabel lbl1,lbl2,lbl3;
//---
long chartID;
int windowNo;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   chartID=ChartID();
   windowNo=ChartWindowFind();
//---
   lbl1.Create(chartID,"Red",windowNo,10,200);
   lbl1.SetInteger(OBJPROP_XSIZE,100);
   lbl1.SetInteger(OBJPROP_YSIZE,50);
   lbl1.Color(clrRed);
   lbl1.Tooltip("\n");
   lbl2.Create(chartID,"Green",windowNo,10,250);
   lbl2.SetInteger(OBJPROP_XSIZE,100);
   lbl2.SetInteger(OBJPROP_YSIZE,50);
   lbl2.Color(clrGreen);
   lbl2.Tooltip("\n");
   lbl3.Create(chartID,"Blue",windowNo,10,300);
   lbl3.SetInteger(OBJPROP_XSIZE,100);
   lbl3.SetInteger(OBJPROP_YSIZE,50);
   lbl3.Color(clrBlue);
   lbl3.Tooltip("\n");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void  OnChartEvent(const int id,       
                   const long& lparam,  
                   const double& dparam, 
                   const string& sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
//---
      if(sparam==lbl1.Name())
         SetColor(lbl1.Color());
      if(sparam==lbl2.Name())
         SetColor(lbl2.Color());
      if(sparam==lbl3.Name())
         SetColor(lbl3.Color());
     }     
  }                     
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetColor(color clr)
  {
   string name;
   int total=ObjectsTotal(chartID,windowNo);
   for(int i=0;i<total;i++)
      if(ObjectType((name=ObjectName(i)))==OBJ_RECTANGLE)
         ObjectSetInteger(chartID,name,OBJPROP_COLOR,clr);
//---
  }    
//+------------------------------------------------------------------+
